program JPEGImage;
{$APPTYPE CONSOLE}
//******************************************************************************
//**                                                                          **
//**  THIS APPLICATION RETUNS FILE PASSED AS A PARAMETER IN A QUERY_STRING AS **
//**  AN JPEG IMAGE. IF NO .INI FILE EXISTS THEN IT USES DEFAULT TEMP         **
//**  DIRECTORY TO SEARCH FOR FILE. AFTER SENDING THE FILE IS DELETED!!!      **
//**  NO PATHNAMES ARE ALLOWED IN QUERY_STRING! GUESS WHY :-)                 **
//**  .INI FILENAME MUST HAVE SAME NAME AS APPLICATION BUT WITH AN .INI       **
//**  EXTENSION.                                                              **
//**                                                                          **
//**  FOR EXAMPLE:                                                            **
//**  JPEGImage.exe AND JPEGImage.ini                                         **
//**  OR                                                                      **
//**  GetJPEG.cgi AND GetJPEG.ini                                             **
//**                                                                          **
//**  HERE IS THE EXAMPLE CONTENTS OF THE INI FILE:                           **
//**  [Settings]                                                              **
//**  Path=d:\Images\                                                         **
//**                                                                          **
//**  AND HERE IS THE EXAMPLE OF THE QUERY STRING TO USE:                     **
//**  http://www.myserver.com/cgi-bin/JPEGImage.cgi?FileName=title.jpg        **
//**                                                                          **
//**    Copyright(c) 2003 by Kiril Antonov, Sofia, Bulgaria, kirila@abv.bg    **
//**                               FREEWARE!!!                                **
//**                USE THIS APPLICATION AT YOUR OWN RISK!!!                  **
//**                                                                          **
//******************************************************************************

uses
  Windows, SysUtils, Classes, IniFiles, Forms;

Type
  TReplaceFlags = set of (rfReplaceAll, rfIgnoreCase);

Var
  FS          : TFileStream;
  FN          : String;
  QueryString : String;
  P           : Integer;
  Ini         : TIniFile;



Function GetDelphiTempPathName:String;
Var
 TmpDir : Array[0..1000] of Char;
Begin
 Result := GetCurrentDir+'\';
 if GetTempPath(1000,TmpDir) <> 0 Then Result := StrPas(TmpDir);
End;

function GetEnvironmentVariable(const Name: string): string;
var
  Len: integer;
begin
  Result := '';
  Len := Windows.GetEnvironmentVariable(PChar(Name), nil, 0);
  if Len > 0 then
  begin
    SetLength(Result, Len - 1);
    Windows.GetEnvironmentVariable(PChar(Name), PChar(Result), Len);
  end;
end;

Function StringReplace(const S, OldPattern, NewPattern: string; Flags: TReplaceFlags): string;
var
  SearchStr, Patt, NewStr: string;
  Offset: Integer;
begin
  if rfIgnoreCase in Flags then
  begin
    SearchStr := AnsiUpperCase(S);
    Patt := AnsiUpperCase(OldPattern);
  end else
  begin
    SearchStr := S;
    Patt := OldPattern;
  end;
  NewStr := S;
  Result := '';
  while SearchStr <> '' do
  begin
    Offset := AnsiPos(Patt, SearchStr);
    if Offset = 0 then
    begin
      Result := Result + NewStr;
      Break;
    end;
    Result := Result + Copy(NewStr, 1, Offset - 1) + NewPattern;
    NewStr := Copy(NewStr, Offset + Length(OldPattern), MaxInt);
    if not (rfReplaceAll in Flags) then
    begin
      Result := Result + NewStr;
      Break;
    end;
    SearchStr := Copy(SearchStr, Offset + Length(Patt), MaxInt);
  end;
end;

Function WWWDecode(ASrc: String): String;
Var
  I        : integer;
  ESC      : String[2];
  CharCode : integer;
Begin
  Result := '';
  ASrc   := StringReplace(ASrc, '+', ' ', [rfReplaceAll]);
  I      := 1;
  While I <= Length(ASrc) do
     Begin
       if ASrc[I] <> '%' Then
           Begin
             Result := Result + ASrc[I]
           End
       Else
           Begin
            Inc(I);
            ESC := Copy(ASrc, I, 2);
            Inc(I, 1);
            Try
              CharCode := StrToInt('$' + ESC);
              if (CharCode > 0) And (CharCode < 256) Then
                  Begin
                    Result := Result + Char(CharCode);
                  End;
            Except
            End;
          End;
       Inc(I);
     End;
End;



Procedure SendFile(ContentType:String;  Stream : TStream);
Const
  CRLF2 = #13#10#13#10;
Var
  F     : File;
  CT    : String;
  NR    : Integer;
  NW    : Integer;
  BUF   : Array[0..10000] of Char;
Begin
  AssignFile(F,'');
  Rewrite(F,1);
  FileMode := fmOpenWrite;
  Try
   CT := 'Content-type: '+ContentType+CRLF2;
   BlockWrite(F,CT[1],Length(CT),NW);
   Stream.Position := 0;
   Repeat
    NR := Stream.Read(BUF,SizeOf(BUF));
    if NR > 0 Then BlockWrite(F,BUF,NR,NW);
   Until NR = 0;
   CloseFile(F);
  Finally
   FileMode := fmOpenReadWrite;
  End;
End;

begin
  QueryString := AnsiUpperCase(WWWDecode(GetEnvironmentVariable('QUERY_STRING')));
  P := Pos('FILENAME=',QueryString);
  if P > 0 Then
     Begin
       System.Delete(QueryString,1,P+Length('FILENAME'));
       FN  := GetDelphiTempPathName;
       Ini := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
       FN  := Ini.ReadString('Settings','Path',FN);
       FN  := FN+ExtractFileName(QueryString);
       if FileExists(FN) Then
          Begin
            FS  := TFileStream.Create(FN,fmOpenRead or fmShareDenyNone);
            Try
              SendFile('image/jpeg',FS);
            Finally
              Ini.Free;
              FS.Free;
              DeleteFile(FN);
            End;
          End;
     End;
end.
